diff --git a/kernel/time/timekeeping.c b/kernel/time/timekeeping.c
index 5a444b8..0a4decb 100644
--- a/kernel/time/timekeeping.c
+++ b/kernel/time/timekeeping.c
@@ -74,7 +74,7 @@ struct timekeeper {
 
 	/* locks for timekeeper structure */
 	seqcount_t rlock;   /* This seqcount serializes readers from updates */
-	spinlock_t wlock;	/* This spinlock serializes updaters */
+	raw_spinlock_t wlock;	/* This spinlock serializes updaters */
 };
 
 static struct timekeeper timekeeper;
@@ -225,13 +225,13 @@ void timekeeping_leap_insert(int leapsecond)
 {
 	unsigned long flags;
 
-	spin_lock_irqsave(&timekeeper.wlock, flags);
+	raw_spin_lock_irqsave(&timekeeper.wlock, flags);
 	write_seqcount_begin(&timekeeper.rlock);
 	timekeeper.xtime_sec += leapsecond;
 	timekeeper.wall_to_monotonic.tv_sec -= leapsecond;
 	timekeeping_update(&timekeeper, false);
 	write_seqcount_end(&timekeeper.rlock);
-	spin_unlock_irqrestore(&timekeeper.wlock, flags);
+	raw_spin_unlock_irqrestore(&timekeeper.wlock, flags);
 
 }
 
@@ -423,7 +423,7 @@ int do_settimeofday(const struct timespec *tv)
 	if ((unsigned long)tv->tv_nsec >= NSEC_PER_SEC)
 		return -EINVAL;
 
-	spin_lock_irqsave(&timekeeper.wlock, flags);
+	raw_spin_lock_irqsave(&timekeeper.wlock, flags);
 	write_seqcount_begin(&timekeeper.rlock);
 
 	timekeeping_forward_now();
@@ -440,7 +440,7 @@ int do_settimeofday(const struct timespec *tv)
 	timekeeping_update(&timekeeper, true);
 
 	write_seqcount_end(&timekeeper.rlock);
-	spin_unlock_irqrestore(&timekeeper.wlock, flags);
+	raw_spin_unlock_irqrestore(&timekeeper.wlock, flags);
 
 	/* signal hrtimers about time change */
 	clock_was_set();
@@ -464,7 +464,7 @@ int timekeeping_inject_offset(struct timespec *ts)
 	if ((unsigned long)ts->tv_nsec >= NSEC_PER_SEC)
 		return -EINVAL;
 
-	spin_lock_irqsave(&timekeeper.wlock, flags);
+	raw_spin_lock_irqsave(&timekeeper.wlock, flags);
 	write_seqcount_begin(&timekeeper.rlock);
 
 	timekeeping_forward_now();
@@ -477,7 +477,7 @@ int timekeeping_inject_offset(struct timespec *ts)
 	timekeeping_update(&timekeeper, true);
 
 	write_seqcount_end(&timekeeper.rlock);
-	spin_unlock_irqrestore(&timekeeper.wlock, flags);
+	raw_spin_unlock_irqrestore(&timekeeper.wlock, flags);
 
 	/* signal hrtimers about time change */
 	clock_was_set();
@@ -638,10 +638,10 @@ void __init timekeeping_init(void)
 	read_boot_clock(&boot);
 
 	seqcount_init(&timekeeper.rlock);
-	spin_lock_init(&timekeeper.wlock);
+	raw_spin_lock_init(&timekeeper.wlock);
 	ntp_init();
 
-	spin_lock_irqsave(&timekeeper.wlock, flags);
+	raw_spin_lock_irqsave(&timekeeper.wlock, flags);
 	write_seqcount_begin(&timekeeper.rlock);
 
 	clock = clocksource_default_clock();
@@ -661,7 +661,7 @@ void __init timekeeping_init(void)
 	timekeeper.total_sleep_time.tv_nsec = 0;
 
 	write_seqcount_end(&timekeeper.rlock);
-	spin_unlock_irqrestore(&timekeeper.wlock, flags);
+	raw_spin_unlock_irqrestore(&timekeeper.wlock, flags);
 
 }
 
@@ -711,7 +711,7 @@ void timekeeping_inject_sleeptime(struct timespec *delta)
 	if (!(ts.tv_sec == 0 && ts.tv_nsec == 0))
 		return;
 
-	spin_lock_irqsave(&timekeeper.wlock, flags);
+	raw_spin_lock_irqsave(&timekeeper.wlock, flags);
 	write_seqcount_begin(&timekeeper.rlock);
 
 	timekeeping_forward_now();
@@ -721,7 +721,7 @@ void timekeeping_inject_sleeptime(struct timespec *delta)
 	timekeeping_update(&timekeeper, true);
 
 	write_seqcount_end(&timekeeper.rlock);
-	spin_unlock_irqrestore(&timekeeper.wlock, flags);
+	raw_spin_unlock_irqrestore(&timekeeper.wlock, flags);
 
 	/* signal hrtimers about time change */
 	clock_was_set();
@@ -744,7 +744,7 @@ static void timekeeping_resume(void)
 
 	clocksource_resume();
 
-	spin_lock_irqsave(&timekeeper.wlock, flags);
+	raw_spin_lock_irqsave(&timekeeper.wlock, flags);
 	write_seqcount_begin(&timekeeper.rlock);
 
 	if (timespec_compare(&ts, &timekeeping_suspend_time) > 0) {
@@ -758,7 +758,7 @@ static void timekeeping_resume(void)
 	timekeeping_suspended = 0;
 
 	write_seqcount_end(&timekeeper.rlock);
-	spin_unlock_irqrestore(&timekeeper.wlock, flags);
+	raw_spin_unlock_irqrestore(&timekeeper.wlock, flags);
 
 	touch_softlockup_watchdog();
 
@@ -776,7 +776,7 @@ static int timekeeping_suspend(void)
 
 	read_persistent_clock(&timekeeping_suspend_time);
 
-	spin_lock_irqsave(&timekeeper.wlock, flags);
+	raw_spin_lock_irqsave(&timekeeper.wlock, flags);
 	write_seqcount_begin(&timekeeper.rlock);
 
 	timekeeping_forward_now();
@@ -804,7 +804,7 @@ static int timekeeping_suspend(void)
 	}
 
 	write_seqcount_end(&timekeeper.rlock);
-	spin_unlock_irqrestore(&timekeeper.wlock, flags);
+	raw_spin_unlock_irqrestore(&timekeeper.wlock, flags);
 
 	clockevents_notify(CLOCK_EVT_NOTIFY_SUSPEND, NULL);
 	clocksource_suspend();
@@ -1061,7 +1061,7 @@ static void update_wall_time(void)
 	unsigned long flags;
 	s64 remainder;
 
-	spin_lock_irqsave(&timekeeper.wlock, flags);
+	raw_spin_lock_irqsave(&timekeeper.wlock, flags);
 
 	/* Make sure we're fully resumed: */
 	if (unlikely(timekeeping_suspended))
@@ -1156,7 +1156,7 @@ static void update_wall_time(void)
 	write_seqcount_end(&timekeeper.rlock);
 
 out:
-	spin_unlock_irqrestore(&timekeeper.wlock, flags);
+	raw_spin_unlock_irqrestore(&timekeeper.wlock, flags);
 
 }
 